import es, cfglib, gamethread, os, playerlib, random, services, popuplib

config = cfglib.AddonCFG(es.getAddonPath("dodgeball") + "/dodgeball.cfg")
config.text("**************************")
config.text("   Downloads and Models   ")
config.text("**************************")
dodgeball_disable_downloads = config.cvar("dodgeball_disable_downloads",   0, "Change to 1 if you are using fast downloads or mani")
dodgeball_radio = config.cvar("dodgeball_radio",   '!enable', "Disable/enable fire in hole sound")
dodgeball_model = config.cvar("dodgeball_model",   1, "Disable/enable Flashbangs been set to dodgeballs")
dodgeball_removebounce = config.cvar("dodgeball_removebounce",   0, "When enabled flashbangs will be removed when they bounce")
dodgeball_knife = config.cvar("dodgeball_knife",   1, "Give players a knife")
dodgeball_give = config.cvar("dodgeball_give",   0, "Give players a flashbangs when they deatonate . When disabled sets flashbangs to 999")
dodgeball_effects = config.cvar("dodgeball_effects",   'smoke', "What trail for flashgrenade' There is smoke,engery and sparks")


config.write()

model_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'models/props/slow/dodgeball/'
material_folder1 =  str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/') + '/' + 'materials/' + 'models/props/slow/dodgeball/'

info = es.AddonInfo()
info.name     = "DodgeBall"
info.version  = "2.1"
info.url      = "None"
info.basename = "sic_dodgeball"
info.author   = "sicman_adrian"
es.ServerVar('sic_dodgeball', info.version, info.name).makepublic()

def load():
    if dodgeball_model:
        es.addons.registerTickListener(setModel)
    if dodgeball_removebounce == 1:
        es.doblock('corelib/noisy_on')
    config.execute()
    if not es.ServerVar("eventscripts_currentmap") == "":
        if dodgeball_model:
            precacheModels()
            if dodgeball_disable_downloads == 0:
                downloadskins()
    if not es.exists('saycommand', str(dodgeball_radio)):
        es.regsaycmd(str(dodgeball_radio), 'dodgeball/radio')
    setup_auth()
    adminmenu_sic = popuplib.create('adminmenu_sic')
    adminmenu_sic.addline('Dodge Ball')
    adminmenu_sic.addline('----------------------')
    adminmenu_sic.addline('Effects')
    adminmenu_sic.addline('->2. Smoke')
    adminmenu_sic.addline('->3. Energy Splash')
    adminmenu_sic.addline('->4. Sparks')
    adminmenu_sic.addline('----------------------')
    adminmenu_sic.menuselect = adminmenu_sic_menuselect
    if not es.exists('command', '!effects'):
        es.regsaycmd('!effects', 'dodgeball/admin')

def unload():
    if dodgeball_model:
        es.addons.unregisterTickListener(setModel)
    if dodgeball_removebounce == 1:
        es.doblock('corelib/noisy_off')
    if es.exists('saycommand', dodgeball_radio):
        es.unregsaycmd(dodgeball_radio)

def es_map_start(ev):
    precacheModels()
    if dodgeball_disable_downloads == 0:
        downloadskins()

def downloadskins():
    for dlfile in os.listdir(model_folder1):
        es.stringtable('downloadables', model_folder1 + dlfile)
    for dlfile_m in os.listdir(material_folder1):
        es.stringtable('downloadables', material_folder1 + dlfile_m)
    es.stringtable('downloadables', 'sound/dodgeball/dodgeballis.mp3')

def precacheModels():
    global dodgeball_model
    dodgeball_model = es.precachemodel('models/props/slow/dodgeball/slow.mdl')

def setModel():
    for i in es.createentitylist('flashbang_projectile'):
        es.setindexprop(i, 'CBaseEntity.m_nModelIndex', dodgeball_model)
        es.setindexprop(i, 'CBaseEntity.m_clrRender', -1)
        effects(i)

def effects(i):
    location = es.getindexprop(i, "CBaseEntity.m_vecOrigin")
    if str(dodgeball_effects) == 'smoke':
        es.effect("smoke", location, "smoke", 5, 0.1)
    if str(dodgeball_effects) == 'engergy':
        es.effect("energysplash", location, location, 0)
    if str(dodgeball_effects) == 'sparks':
        es.effect("sparks", location, 1, 5, location)

def adminmenu_sic_menuselect(userid, choice, popupid):
    if choice == 1:
        dodgeball_effects = 'smoke'
    elif choice == 2:
          dodgeball_effects = 'energy'
    elif choice == 3:
          dodgeball_effects = 'sparks'

def grenade_bounce(ev):
    if dodgeball_removebounce == 1:
        es.server.queuecmd("es_fire %s flashbang_projectile kill" % ev['userid'])

def weapon_fire(ev):
    userid = ev['userid']
    myPlayer = playerlib.getPlayer(userid)
    alive = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
    if ev['weapon'] == 'flashbang':
         if not alive:
            if dodgeball_give == 1:
                if dodgeball_knife == 1:
                    gamethread.delayed(0.5, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % userid)
                else:
                    gamethread.delayed(0.9, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % userid)
            elif dodgeball_give == 0:
                  myPlayer.set('fb', 999)
                  es.msg('1')

def player_spawn(ev):
    userid = ev['userid']
    alive = es.getplayerprop(userid, "CBasePlayer.pl.deadflag")
    myPlayer = playerlib.getPlayer(userid)
    if ev['es_userteam'] >= '2':
        if not alive:
            es.server.queuecmd('es_xfire %s player_weaponstrip kill' % userid)
            es.server.queuecmd('es_xgive %s player_weaponstrip' % userid)
            es.server.queuecmd('es_xfire %s player_weaponstrip strip' % userid)
            gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % userid)
            es.setplayerprop(userid, "CBasePlayer.m_iHealth", 1)
            if dodgeball_knife:
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_knife' % userid)

''''
def player_hurt(ev):
    userid = ev['userid']
    if ev['weapon'] == 'flashbang':
        es.server.queuecmd('damage %s 99 2 %s'%(ev['userid'], ev['attacker']))
'''

def player_activate(ev):
    es.cexec(ev['userid'], 'play dodgeball/dodgeballis.mp3')
    es.cexec(ev['userid'], 'ignorerad')

def radio():
    userid = es.getcmduserid()
    es.cexec(userid, 'ignorerad')

def flashbang_detonate(ev):
    es.setplayerprop(ev['userid'], 'CCSPlayer.m_flFlashMaxAlpha', 0)
    es.setplayerprop(ev['userid'], 'CCSPlayer.m_flFlashDuration', 0)
    if dodgeball_removebounce == 0:
        if es.getplayerprop(ev['userid'], "CBasePlayer.pl.deadflag") == 0:
            if dodgeball_give:
                gamethread.delayed(0.1, es.server.queuecmd, 'es_xgive %s weapon_flashbang' % ev['userid'])

def player_blind(ev):
    es.setplayerprop(ev['userid'], 'CCSPlayer.m_flFlashMaxAlpha', 0)
    es.setplayerprop(ev['userid'], 'CCSPlayer.m_flFlashDuration', 0)

def round_start(ev):
    userid = es.getuserid()
    if userid:
        es.server.queuecmd('es_xfire %s func_hostage_rescue kill'% userid)
        es.server.queuecmd('es_xfire %s hostage_entity kill'% userid)
        es.server.queuecmd('es_xfire %s func_bomb_target kill'% userid)
        es.server.queuecmd('es_xfire %s func_buyzone kill'% userid)
    entlist = es.createentitylist()
    for index in entlist:
       if entlist[index]['classname'].startswith('weapon_') and es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
          es.server.queuecmd('es_xremove %s' % index)

def player_death(ev):
    entlist = es.createentitylist()
    for index in entlist:
       if entlist[index]['classname'].startswith('weapon_') and es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
          es.server.queuecmd('es_xremove %s' % index)
    if ev['attacker']:
        if ev['es_userteam'] == '2':
            if playerlib.getUseridList('#ct,#dead'):
                es.server.queuecmd('est_spawn %s'% random.choice(playerlib.getUseridList('#ct,#dead')))
        elif ev['es_userteam'] == '3':
              if playerlib.getUseridList('#t,#dead'):
                  es.server.queuecmd('est_spawn %s 0'% random.choice(playerlib.getUseridList('#t,#dead')))

def admin():
    userid = es.getcmduserid()
    if isAuthed(userid):
        popuplib.unsend('adminmenu_sic', userid)
        popuplib.send('adminmenu_sic', userid)
    else:
        es.tell(userid, '#multi','#greenYou are not authorized to run this command')

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('dodgeball_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'dodgeball_admin')
    else:
        isAuthed = lambda x: False